<?php
# Copyright 2009 Atomicorp a subsidiary of Prometheus Global, Inc., 
# All Rights Reserved.
# http://www.atomicorp.com
#
# This is copyright protected software.  Use of this Software is 
# ruled by the terms of the End User License Agreement, included in 
# or with the Software (EULA). Final user must accept the terms of 
# the EULA in order to install and use the Software.
#
# Distribution of this work or derivative of this work in any form is 
# prohibited unless prior written permission is obtained from the 
# copyright holder. 
#
# COPY OR REPRODUCTION OF THIS SOFTWARE ON ANOTHER SYSTEM OR POSITIONING 
# IN ORDER TO FACILITATE SUCH COPYING OR DISTRIBUTION IS STRICTLY FORBIDDEN.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS   
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE   
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE   
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR   
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF   
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN   
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)   
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF   
# THE POSSIBILITY OF SUCH DAMAGE.

include_once(PRODUCT_ROOT."/admin/plib/modules/pm.php");
if (!$session->chkLevel(IS_ADMIN)) {
        pm_alert(pm_lmsg('__perm_denied').'You must be admin to use this page');
        go_to_uplevel();
}

class AjaxRequest {
	var $req;
	var $templates;
	var $template;
	var $data;
	
	function AjaxRequest($get,$post) {
		$this->req=$this->prep_request($get,$post);
		$this->templates=array(
			"test"		=>"test.tmp",
			"dashboard"	=>array(
				"vulnerability"			=>"db_vulnerability.tmp",
				"vulnerability_detail"	=>"db_vulnerability_detail.tmp",
				"bulletin"				=>"db_bulletin.tmp",
				"sig_update"			=>"db_sig_update.tmp",
				"sec_module"			=>"db_sec_module.tmp",
				"file_check"			=>"db_file_check.tmp",
				"file_detail"			=>"db_file_detail.tmp",
				"sec_event"				=>"db_sec_event.tmp",
				"sec_event_detail"		=>"db_sec_event_detail.tmp",
				"dtl_whitelist"			=>"db_dtl_interact.tmp",
				"dtl_disable"			=>"db_dtl_interact.tmp",
				"dtl_false"				=>"db_dtl_interact.tmp"
			),
			"inventory"	=>"inv_detail.tmp",
			"blocklist" =>array(
				"block"					=>"blocklist_detail.tmp",
				"black"					=>"blocklist_detail_black.tmp",
				"white"					=>"blocklist_detail_white.tmp",
				"geo"					=>"blocklist_detail_geo.tmp"
			),
			"config"	=>array(
				"get_configs"			=>"config_get.tmp",
				"load_config"			=>"config_load.tmp",
				"save_config"			=>"config_save.tmp",
				"get_help"				=>"config_help.tmp"
			)
		);
		
		if (!empty($this->req["sub"])) 	{$this->template=$this->templates[$this->req["display"]][$this->req["sub"]];}
		else 							{$this->template=$this->templates[$this->req["display"]];}
		$this->data=array();
		$this->init();
	}
	
	function prep_request($get,$post) {
		//$arrTemp=array(
		//	"display"=>$get["display"],
		//	"sub"=>$get["sub"]
		//);
		
		foreach ($get AS $k=>$v) {$arrTemp[$k]=$v;}
		foreach ($post AS $k=>$v){$arrTemp[$k]=$v;}
		
		return $arrTemp;
	}
}
?>
