<?php
# Copyright 2009 Atomicorp a subsidiary of Prometheus Global, Inc., 
# All Rights Reserved.
# http://www.atomicorp.com
#
# This is copyright protected software.  Use of this Software is 
# ruled by the terms of the End User License Agreement, included in 
# or with the Software (EULA). Final user must accept the terms of 
# the EULA in order to install and use the Software.
#
# Distribution of this work or derivative of this work in any form is 
# prohibited unless prior written permission is obtained from the 
# copyright holder. 
#
# COPY OR REPRODUCTION OF THIS SOFTWARE ON ANOTHER SYSTEM OR POSITIONING 
# IN ORDER TO FACILITATE SUCH COPYING OR DISTRIBUTION IS STRICTLY FORBIDDEN.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS   
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE   
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE   
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR   
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF   
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN   
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)   
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF   
# THE POSSIBILITY OF SUCH DAMAGE.

include_once(PRODUCT_ROOT."/admin/plib/modules/pm.php");
if (!$session->chkLevel(IS_ADMIN)) {
        pm_alert(pm_lmsg('__perm_denied').'You must be admin to use this page');
        go_to_uplevel();
}



class Blocklist extends AjaxRequest {
	
	function init()	{
		$this->unblock_ips();
		$this->whitelist_ips();
		$this->blacklist_ips();
		
		
		$white=array();
		if ($fh=fopen("/etc/asl/whitelist","r")) {
			while ($line=fgets($fh,1024)) {
				$v=trim($line);
				$white[$v]=1;
			}
			fclose($fh);
		}

		$black=array();
		if ($fh=fopen("/etc/asl/blacklist","r")) {
			while ($line=fgets($fh,1024)) {
				$v=trim($line);
				$black[$v]=1;
			}
			fclose($fh);
		}

		$first=(($this->req["page"]-1)*20)+1;
		$last=($this->req["page"]*20)-1;
		$i=1;
		//$this->data["blocklist"][]=array("time"=>$first,"ip"=>$last,"signature"=>$this->req["page"]." - ".$_GET["page"]);
		$dbh = new PDO('sqlite:/var/ossec/var/blocklist.sqlite');
		foreach ($dbh->query('SELECT ip, time, rule FROM hackers') as $val)  {

			if ($i>=$first && $i<=$last) {
				$time=strftime("%a %b %d %H:%M:%S %Z %Y", $val[time]);

				if (isset($white[$val[ip]])) {$is_white=1;} else {$is_white=0;}
				if (isset($black[$val[ip]])) {$is_black=1;} else {$is_black=0;}
				$this->data["blocklist"][]=array(
					"time"=>strftime("%a %b %d %H:%M:%S %Z %Y", $val[time]),

					"ip"=>$val[ip], 
					"signature"=>$val[rule],
					"is_white"=>$is_white,
					"is_black"=>$is_black
				);


			}
			$i++;
			$this->data["item_count"]++;
		}

	}
	
	function unblock_ips() {
		if (count($this->req["unblock_ip"]) >= 1) {
			foreach ($this->req["unblock_ip"] AS $k=>$v) {
				system("sudo /var/asl/bin/asl -ub ".$v);
			}
		}
	}
	
	function whitelist_ips() {
		//if (count($this->req["whitelist_ip"])) {
			foreach ($this->req["whitelist_ip"] AS $k=>$v) {
				exec("sudo /var/asl/bin/asl --unblock ".$v);
				exec("sudo /var/asl/bin/asl --whitelist ".$v);
			}
		//}
	}
	
	function blacklist_ips() {
		//if (count($this->req["blacklist_ip"])) {
			foreach ($this->req["blacklist_ip"] AS $k=>$v) {
				exec("sudo /var/asl/bin/asl --unblock ".$v);
				exec("sudo /var/asl/bin/asl --blacklist ".$v);
			}
		//}
	}
}
?>
