<?php
# Copyright 2009 Atomicorp a subsidiary of Prometheus Global, Inc., 
# All Rights Reserved.
# http://www.atomicorp.com
#
# This is copyright protected software.  Use of this Software is 
# ruled by the terms of the End User License Agreement, included in 
# or with the Software (EULA). Final user must accept the terms of 
# the EULA in order to install and use the Software.
#
# Distribution of this work or derivative of this work in any form is 
# prohibited unless prior written permission is obtained from the 
# copyright holder. 
#
# COPY OR REPRODUCTION OF THIS SOFTWARE ON ANOTHER SYSTEM OR POSITIONING 
# IN ORDER TO FACILITATE SUCH COPYING OR DISTRIBUTION IS STRICTLY FORBIDDEN.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS   
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE   
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE   
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR   
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF   
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN   
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)   
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF   
# THE POSSIBILITY OF SUCH DAMAGE.

include_once(PRODUCT_ROOT."/admin/plib/modules/pm.php");
if (!$session->chkLevel(IS_ADMIN)) {
        pm_alert(pm_lmsg('__perm_denied').'You must be admin to use this page');
        go_to_uplevel();
}

class DB_Bulletin extends AjaxRequest {
	// Something in Plesk is preventing this from running
	//var $file_rss="http://3es.atomicrocketturtle.com/Changelog.rss";
	var $file_rss="/var/asl/data/Changelog.rss";
	var $max_links=9;
	var $num_links=0;
	var $open_items=array();
	
	function init()	{
		if (!($fp=fopen($this->file_rss,"r"))) {
			// error
		}
		else {
			$xml_parser=xml_parser_create();
			xml_set_object($xml_parser,$this);
			xml_set_element_handler($xml_parser,start_element,end_element);
			xml_set_character_data_handler($xml_parser,contents);
			while ($line=fgets($fp)) {
				xml_parse($xml_parser,$line);
				if ($this->max_links==$this->num_links) {break;}
			}
			xml_parser_free($xml_parser);
			fclose($fp);
		}
	}

	function start_element($parser,$name) {
		array_push($this->open_items,$name);
	}
	
	function end_element($parser,$name) {
		array_pop($this->open_items);
		if ($name=="ITEM") {$this->num_links++;}
	}
	
	function contents($parser,$data) {
		if (isset($this->open_items[0]) && isset($this->open_items[1]) && isset($this->open_items[2])) {
		if ($this->open_items[0]=="RSS" 
			&& $this->open_items[1]=="CHANNEL" 
			&& $this->open_items[2]=="ITEM" 
			&& sizeof($this->open_items)==4) {
			
			if ($this->open_items[3]=="LINK") {
				$this->data[$this->num_links]["link"]=$data;
			}
			else if ($this->open_items[3]=="TITLE") {
				$this->data[$this->num_links]["title"]=$data;
			}
		}
		}
	}
}
?>
