<?php
# Copyright 2009 Atomicorp a subsidiary of Prometheus Global, Inc., 
# All Rights Reserved.
# http://www.atomicorp.com
#
# This is copyright protected software.  Use of this Software is 
# ruled by the terms of the End User License Agreement, included in 
# or with the Software (EULA). Final user must accept the terms of 
# the EULA in order to install and use the Software.
#
# Distribution of this work or derivative of this work in any form is 
# prohibited unless prior written permission is obtained from the 
# copyright holder. 
#
# COPY OR REPRODUCTION OF THIS SOFTWARE ON ANOTHER SYSTEM OR POSITIONING 
# IN ORDER TO FACILITATE SUCH COPYING OR DISTRIBUTION IS STRICTLY FORBIDDEN.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS AS IS   
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE   
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE   
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR   
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF   
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN   
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)   
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF   
# THE POSSIBILITY OF SUCH DAMAGE.

include_once(PRODUCT_ROOT."/admin/plib/modules/pm.php");
if (!$session->chkLevel(IS_ADMIN)) {
        pm_alert(pm_lmsg('__perm_denied').'You must be admin to use this page');
        go_to_uplevel();
}

include_once("/etc/asl/web.conf");

class DB_SecEventDetail extends AjaxRequest {
	var $dns="http://whois.domaintools.com";
	//var $audit_path="/var/asl/data/";
	var $audit_path="";
	var $whitelist_path="/etc/asl/whitelist";

	function init() {
		if (!preg_match("/\./",$_GET["ip"]) && $_GET["ip"]!="0") {
			$t=$this->dec2ip($_GET["ip"]);
		}
		else {$t=$_GET["ip"];}
		
		$this->data=array(
			"filename"=>$_GET['filename'],
			"vhost"=>$_GET['vhost'],
			"ip"=>$t,
			"request"=>$_GET['request'],
			"logname"=>$_GET['logname'],
			"sig_id"=>$_GET['sig_id'],
			"details"=>$_GET['details'],
			"flag_whitelist"=>0,
			"flag_disabled"=>0,
			"flag_false"=>0,
			"lines"=>array()
		);


		
		$f=file("/etc/asl/whitelist");
		foreach ($f AS $k=>$v) {
			if (trim($v)==$_GET["ip"]) {$this->data["flag_whitelist"]=1;}
		}
		
		$f=file("/etc/asl/disabled_signatures");
		foreach ($f AS $k=>$v) {
			if (trim($v)==$_GET["sig_id"]) {$this->data["flag_disabled"]=1;}
		}
		
		// mod_sec sig_ids are greater than 100000
		if (ALERTS_USE_DB==1 && $this->data['sig_id'] < 99999) {
			$dbc=mysql_connect(DB_HOST,DB_USER,DB_PASS);
			$db=mysql_select_db(DB_NAME,$dbc);

			$sql="SELECT full_log FROM data WHERE id='".$_GET["id"]."'";
			$q=mysql_query($sql);
			$r=mysql_fetch_assoc($q);

			$this->data["lines"][]=wordwrap(htmlspecialchars(addslashes($r["full_log"])),147,"<br>\n",true);
			
			
			mysql_close($dbc);
		}
		else {
			exec("sudo /var/asl/bin/asl --show-alert ".$this->audit_path.$this->req["filename"],$lines);
		
			if (count($lines)) {
				foreach ($lines AS $k=>$v) {
					
					$this->data["lines"][]=wordwrap(htmlspecialchars($v),147,"<br>\n",true);
				}
				// check whitelist
				if ($tmp=file($this->whitelist_path)) {
					foreach ($tmp AS $k=>$v) {
						if (trim($v)==$_GET["ip"]) {$this->data["flag_whitelist"]=1;}
					}
				}
			}
			else {
				$this->data["lines"][]="Failed to open ".$this->audit_path.$this->req["filename"].".";
			}
		}
	}

	function dec2ip($dec) {
		if ($dec<0) {$dec=(double) 4294967296+dec;}
		if ($dec>16777215) {
			$ip=$dec-(intval($dec/256)*256);
			$dec=(double) intval($dec/256);
		}
		else {$ip="0";}
		if ($dec>65535) {
			$ip=($dec-(intval($dec/256)*256)).".".$ip;
			$dec=(double) intval($dec/256);
		}
		else {$ip="0.".$ip;}
		if ($dec>255) {
			$ip=($dec-(intval($dec/256)*256)).".".$ip;
			$dec=(double) intval($dec/256);
		}
		else {$ip="0.".$ip;}
		$ip=$dec.".".$ip;
		return $ip;
	}
}
?>
